'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _tasks = require('buildorders/tasks');

var tasks = _interopRequireWildcard(_tasks);

var _taskAPI = require('taskAPI');

var _taskAPI2 = _interopRequireDefault(_taskAPI);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref) {
    var _bin;

    var flags = _ref.flags;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return tasks.bootstrap({ name: flags.name });

          case 2:
            _context.next = 4;
            return tasks.mocha();

          case 4:
            _context.next = 6;
            return tasks.prettier();

          case 6:
            _context.next = 8;
            return tasks.eslint({
              packages: 'eslint-config-esayemm',
              extend: 'eslint-config-esayemm'
            });

          case 8:
            _context.next = 10;
            return _taskAPI2.default.addPackages({
              packages: ['app-module-path'],
              devPackages: ['jbs-node', 'babel-register', 'babel-polyfill']
            });

          case 10:
            _context.next = 12;
            return _taskAPI2.default.addToPackageJson({
              json: {
                scripts: {
                  build: 'rm -rf build && ./node_modules/jbs-node/bin.js build --input src --output build',
                  prepublish: 'npm run build',
                  preversion: 'npm run lint && npm run test',
                  version: 'npm publish',
                  postversion: 'git add . && git push && git push --tags'
                },
                babel: {
                  presets: ['./node_modules/jbs-node/configs/babel-preset-jbs-node.js']
                },
                preferGlobal: true,
                bin: (_bin = {}, (0, _defineProperty3.default)(_bin, flags.name + '-dev', './dev.entry.js'), (0, _defineProperty3.default)(_bin, flags.name, './entry.js'), _bin),
                files: ['entry.js', 'dev.entry.js', 'build/']
              }
            });

          case 12:
            _context.next = 14;
            return _taskAPI2.default.addFile({
              dest: './dev.entry.js',
              fileContent: ['#!/usr/bin/env node', '// use this for dev, production will use ./entry.js', 'const path = require(\'path\')', 'require(\'app-module-path\').addPath(path.resolve(__dirname, \'./src\'))', 'require(\'babel-register\')', 'require(\'babel-polyfill\')', 'require(\'./src\')'].join('\n'),
              chmod: '0755'
            });

          case 14:
            _context.next = 16;
            return _taskAPI2.default.addFile({
              dest: './entry.js',
              fileContent: ['#!/usr/bin/env node', 'const path = require(\'path\')', 'require(\'app-module-path\').addPath(path.resolve(__dirname, \'./build\'))', 'require(\'./build\')'].join('\n'),
              chmod: '0755'
            });

          case 16:
            _context.next = 18;
            return _taskAPI2.default.shell({ command: 'mkdir src' });

          case 18:
            _context.next = 20;
            return _taskAPI2.default.shell({ command: 'touch src/index.js' });

          case 20:
            if (!flags.git) {
              _context.next = 23;
              break;
            }

            _context.next = 23;
            return _taskAPI2.default.gitInit();

          case 23:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function cli(_x) {
    return _ref2.apply(this, arguments);
  }

  return cli;
}();