'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _tasks = require('../../tasks');

var tasks = _interopRequireWildcard(_tasks);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _taskAPI = require('taskAPI');

var _taskAPI2 = _interopRequireDefault(_taskAPI);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref) {
    var flags = _ref.flags;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return tasks.bootstrap({ name: flags.name });

          case 2:
            _context.next = 4;
            return tasks.storybook();

          case 4:
            _context.next = 6;
            return tasks.prettier();

          case 6:
            _context.next = 8;
            return tasks.eslint({
              packages: 'eslint-config-esayemm',
              extend: 'eslint-config-esayemm/react'
            });

          case 8:
            _context.next = 10;
            return tasks.ci();

          case 10:
            _context.next = 12;
            return _taskAPI2.default.addPackages({
              packages: ['react-addons-test-utils', 'react', 'prop-types', 'react-dom', 'react-helmet', 'react-router', 'react-router-dom', 'history', 'html', 'invariant', 'esayemm-styles', 'classnames'],
              devPackages: ['jbs-fe']
            });

          case 12:
            _context.next = 14;
            return _taskAPI2.default.addToPackageJson({
              json: {
                main: './build/index.js',
                scripts: {
                  build: 'BABEL_REACT=true NODE_PATH=./src ./node_modules/jbs-fe/bin.js build --app-index ./src/app/index.js',
                  start: 'BABEL_REACT=true NODE_PATH=./src ./node_modules/jbs-fe/bin.js dev --app-index ./src/app/index.js',
                  test: 'BABEL_REACT=true NODE_PATH=./src ./node_modules/jbs-fe/bin.js test --single-run',
                  'test:watch': 'BABEL_REACT=true NODE_PATH=./src ./node_modules/jbs-fe/bin.js test',
                  deploy: 'npm run build && echo add deployment script here'
                },
                babel: {
                  presets: ['./node_modules/jbs-fe/configs/babel-preset-jbs-fe.js']
                }
              }
            });

          case 14:
            _context.next = 16;
            return _taskAPI2.default.copy({
              src: _path2.default.resolve(__dirname, '../../templates/react-app/src'),
              dest: './src'
            });

          case 16:
            if (!flags.git) {
              _context.next = 19;
              break;
            }

            _context.next = 19;
            return _taskAPI2.default.gitInit();

          case 19:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function reactApp(_x) {
    return _ref2.apply(this, arguments);
  }

  return reactApp;
}();