'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildorders = exports.list = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/*
 * list prints name of all the buildorders
 */
var list = exports.list = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var dir;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            dir = _config2.default.DEFAULT_BUILD_ORDERS_DIR;

            _fs2.default.readdirSync(dir).map(function (filename) {
              return _fs2.default.lstatSync(_path2.default.resolve(dir, filename)).isDirectory() && filename;
            }).filter(Boolean).forEach(function (name) {
              return console.log(name);
            });

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function list() {
    return _ref.apply(this, arguments);
  };
}();

/*
 * buildorders executes a buildorder
 */


var buildorders = exports.buildorders = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref2) {
    var flags = _ref2.flags,
        commands = _ref2.commands;
    var name, taskHeader, handler;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            name = commands[0];
            taskHeader = 'BUILD ORDER';

            (0, _logger.taskAPILogHeader)(taskHeader, name);
            handler = _requireHandlerRelative({ name: name });
            _context2.t0 = handler;
            _context2.t1 = flags;
            _context2.t2 = _process2.default.cwd();
            _context2.next = 9;
            return (0, _shellAliases.getProjectRootPath)();

          case 9:
            _context2.t3 = _context2.sent;
            _context2.t4 = {
              cwd: _context2.t2,
              projectRootPath: _context2.t3
            };
            _context2.t5 = _taskAPI2.default;
            _context2.t6 = {
              flags: _context2.t1,
              env: _context2.t4,
              taskAPI: _context2.t5
            };
            _context2.next = 15;
            return (0, _context2.t0)(_context2.t6);

          case 15:
            (0, _logger.taskAPILogHeader)('END ' + taskHeader, name);
            console.log(_chalk2.default.green('All done!'));

          case 17:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function buildorders(_x) {
    return _ref3.apply(this, arguments);
  };
}();

/**
 * _requireHandlerRelative returns functions from files relative to defaultDir
 *
 * @param {string} name - names are basenames in directory
 * config.DEFAULT_BUILD_ORDERS_DIR
 * @param {string} defaultDir
 * @returns {array.<function>}
 */


var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _process = require('process');

var _process2 = _interopRequireDefault(_process);

var _config = require('config');

var _config2 = _interopRequireDefault(_config);

var _taskAPI = require('taskAPI');

var _taskAPI2 = _interopRequireDefault(_taskAPI);

var _logger = require('utils/logger');

var _shellAliases = require('utils/shellAliases');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _requireHandlerRelative(_ref4) {
  var name = _ref4.name,
      _ref4$defaultDir = _ref4.defaultDir,
      defaultDir = _ref4$defaultDir === undefined ? _config2.default.DEFAULT_BUILD_ORDERS_DIR : _ref4$defaultDir;

  var handlerPath = _path2.default.resolve(defaultDir, name);
  (0, _invariant2.default)(_fs2.default.existsSync(handlerPath), name + ' is not a file or a default');
  var handler = require(handlerPath).default || require(handlerPath);
  (0, _invariant2.default)(handler || typeof handler === 'function', name + ' must export a function');
  return handler;
}