'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var initialize = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _shellAliases.areCommandsInstalled)([['yarn', 'npm'], 'git']);

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function initialize() {
    return _ref.apply(this, arguments);
  };
}();

var main = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return initialize();

          case 2:
            _context2.next = 4;
            return setupCommanderShepard();

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function main() {
    return _ref2.apply(this, arguments);
  };
}();

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _commanderShepard = require('commander-shepard');

var _commands = require('commands');

var _npmClientAdapter = require('npmClientAdapter');

var _npmClientAdapter2 = _interopRequireDefault(_npmClientAdapter);

var _shellAliases = require('utils/shellAliases');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function setupCommanderShepard() {
  var commander = new _commanderShepard.Commander({
    key: 'bojs',
    packageJson: require('../package.json'),
    longDescription: 'set up your javascript project procedurally',
    flags: [{
      keys: ['npm'],
      required: false,
      shortDescription: 'specify npm client to use [npm || yarn] defaults to npm'
    }, {
      keys: ['git'],
      required: false,
      shortDescription: 'initialize empty git repo'
    }]
  });
  commander.use('buildorders', new _commanderShepard.Command({
    handler: _commands.buildorders,
    shortDescription: 'apply buildorders to the current project'
  }));
  commander.use('list', new _commanderShepard.Command({
    handler: _commands.list,
    shortDescription: 'list the available buildorders'
  }));
  _npmClientAdapter2.default.setAdapter(commander.runtimeData.flags.npm || 'npm');
  return commander.start();
}

main().catch(function (e) {
  return console.log(_chalk2.default.red(e.message, e.stack));
});