'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _execAsync = require('utils/execAsync');

var _execAsync2 = _interopRequireDefault(_execAsync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var adapters = {
  npm: {
    add: function add(keys, _ref) {
      var dev = _ref.dev;

      keys = [].concat(keys);
      var options = dev ? '--save-dev' : '--save';
      return (0, _execAsync2.default)('npm i ' + keys.join(' ') + ' ' + options, { pipe: true });
    }
  },

  yarn: {
    add: function add(keys, _ref2) {
      var dev = _ref2.dev;

      keys = [].concat(keys);
      var options = dev ? '--dev' : '--save';
      return (0, _execAsync2.default)('yarn add ' + keys.join(' ') + ' ' + options, { pipe: true });
    }
  }
};

var NpmClientAdapter = function () {
  function NpmClientAdapter() {
    (0, _classCallCheck3.default)(this, NpmClientAdapter);
    this.adapter = null;
  }

  (0, _createClass3.default)(NpmClientAdapter, [{
    key: 'setAdapter',
    value: function setAdapter(key) {
      (0, _invariant2.default)(adapters[key], '\'' + key + '\' must be one of ' + (0, _keys2.default)(adapters));
      this.adapter = adapters[key];
    }
  }, {
    key: 'add',
    value: function add() {
      var _adapter;

      return (_adapter = this.adapter).add.apply(_adapter, arguments);
    }
  }]);
  return NpmClientAdapter;
}();

exports.default = new NpmClientAdapter();