'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _npmClientAdapter = require('npmClientAdapter');

var _npmClientAdapter2 = _interopRequireDefault(_npmClientAdapter);

var _execAsync = require('utils/execAsync');

var _execAsync2 = _interopRequireDefault(_execAsync);

var _fsUtils = require('utils/fsUtils');

var _logger = require('utils/logger');

var _noCacheRequire = require('utils/noCacheRequire');

var _noCacheRequire2 = _interopRequireDefault(_noCacheRequire);

var _shellAliases = require('utils/shellAliases');

var _stringFormatter = require('utils/stringFormatter');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TaskAPI = function () {
  function TaskAPI() {
    (0, _classCallCheck3.default)(this, TaskAPI);
  }

  (0, _createClass3.default)(TaskAPI, [{
    key: 'shell',

    /**
     * shell executes a shell command
     *
     * @param {string} command - shell command to run (interactive commands
     * doesn't work)
     */
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            command = _ref2.command;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Shell');
                console.log(_chalk2.default.yellow('\n  Running command ' + command + '\n'));
                _context.next = 4;
                return (0, _execAsync2.default)(command, { log: true });

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function shell() {
        return _ref.apply(this, arguments);
      }

      return shell;
    }()

    /**
     * gitInit executes an initial commit
     *
     * @param {Object} opts
     * @param {String} [initMessage] - git init message
     */

  }, {
    key: 'gitInit',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            _ref4$initMessage = _ref4.initMessage,
            initMessage = _ref4$initMessage === undefined ? '\u0CA0_\u0CA0' : _ref4$initMessage;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Git Init');
                _context2.next = 3;
                return (0, _execAsync2.default)('git add .', { log: true });

              case 3:
                _context2.next = 5;
                return (0, _execAsync2.default)('git commit -m \'' + initMessage + '\'', { log: true });

              case 5:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function gitInit() {
        return _ref3.apply(this, arguments);
      }

      return gitInit;
    }()

    /**
     * addPackages adds an npm package using the npmAdapter
     *
     * @param {array.<string>} packages - npm packages to install
     * @param {array.<string>} devPackages - npm dev packages to install
     */

  }, {
    key: 'addPackages',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            _ref6$devPackages = _ref6.devPackages,
            devPackages = _ref6$devPackages === undefined ? [] : _ref6$devPackages,
            _ref6$packages = _ref6.packages,
            packages = _ref6$packages === undefined ? [] : _ref6$packages;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Add Package');

                if (!devPackages.length) {
                  _context3.next = 5;
                  break;
                }

                this._printPackages(devPackages, true);
                _context3.next = 5;
                return _npmClientAdapter2.default.add(devPackages, { dev: true });

              case 5:
                if (!packages.length) {
                  _context3.next = 9;
                  break;
                }

                this._printPackages(packages);
                _context3.next = 9;
                return _npmClientAdapter2.default.add(packages, { dev: false });

              case 9:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function addPackages() {
        return _ref5.apply(this, arguments);
      }

      return addPackages;
    }()
  }, {
    key: '_printPackages',
    value: function _printPackages() {
      var packages = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var dev = arguments[1];

      console.log(_chalk2.default.yellow('\n  Adding packages to ' + (dev ? 'devDependencies' : 'dependencies') + '\n'));
      var paddedPackagesStr = (0, _stringFormatter.leftPad)(packages.join('\n'), ' ', 2);
      if (packages.length) {
        console.log(_chalk2.default.yellow(paddedPackagesStr));
        console.log('');
      }
    }

    /**
     * addToJsonFile merges the given object to the json file
     *
     * @param {Object} opts
     * @param {Object} json          - plain object to merge to dest file
     * @param {String} dest          - json file path to merge into or will be created if
     * does not exists
     */

  }, {
    key: 'addToJsonFile',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            json = _ref8.json,
            dest = _ref8.dest;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Add JSON File');
                _context4.next = 3;
                return (0, _fsUtils.relativeFromProjectRoot)(dest);

              case 3:
                dest = _context4.sent;

                if (!_fsExtra2.default.existsSync(dest)) {
                  _fsExtra2.default.writeFileSync(dest, '{}', { encoding: 'utf8' });
                }
                _fsExtra2.default.writeFileSync(dest, (0, _stringify2.default)(_lodash2.default.merge((0, _noCacheRequire2.default)(dest), json), null, '  '));

              case 6:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function addToJsonFile() {
        return _ref7.apply(this, arguments);
      }

      return addToJsonFile;
    }()

    /**
     * addToPackageJson merges object into package.json file
     *
     * @param {Object} opts
     * @param {Object} json          - json to merge into package.json
     */

  }, {
    key: 'addToPackageJson',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var _ref10 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            json = _ref10.json;

        var projectRootPath;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Add to package.json');
                _context5.next = 3;
                return (0, _shellAliases.getProjectRootPath)();

              case 3:
                projectRootPath = _context5.sent;
                _context5.next = 6;
                return this.addToJsonFile({
                  json: json,
                  dest: _path2.default.resolve(projectRootPath, 'package.json')
                });

              case 6:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function addToPackageJson() {
        return _ref9.apply(this, arguments);
      }

      return addToPackageJson;
    }()

    /**
     * addDirectory makes a directory
     *
     * @param {Object} opts
     * @param {String} dest          - destination file path
     */

  }, {
    key: 'addDirectory',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var _ref12 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            dest = _ref12.dest;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Add Directory');
                _context6.next = 3;
                return (0, _fsUtils.relativeFromProjectRoot)(dest);

              case 3:
                dest = _context6.sent;

                if (!_fsExtra2.default.existsSync(dest)) {
                  _context6.next = 7;
                  break;
                }

                console.log(_chalk2.default.gray('\n  Directory already exists ' + dest + '\n'));
                return _context6.abrupt('return');

              case 7:
                console.log(_chalk2.default.yellow('\n  Making dir -> ' + dest + '\n'));
                _fsExtra2.default.mkdirSync(dest);

              case 9:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function addDirectory() {
        return _ref11.apply(this, arguments);
      }

      return addDirectory;
    }()

    /**
     * addFile creates a file with the given content
     *
     * @param {Object} opts
     * @param {String} src           - File path
     * @param {String} [fileContent] - Contents of file to add, you can provide
     * this instead of a src file to copy over
     * @param {String} dest          - Destination of file to add
     * @param {Boolean} [overwrite]   - overwrite file if doesn't exist
     */

  }, {
    key: 'addFile',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
        var _ref14 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            src = _ref14.src,
            fileContent = _ref14.fileContent,
            dest = _ref14.dest,
            overwrite = _ref14.overwrite,
            chmod = _ref14.chmod;

        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Add File');
                _context7.next = 3;
                return (0, _fsUtils.relativeFromProjectRoot)(dest);

              case 3:
                dest = _context7.sent;

                (0, _invariant2.default)(typeof fileContent === 'string' || _fsExtra2.default.existsSync(src), 'Must provide either \'fileContent\':String or \'src\':filepath');
                fileContent = [null, undefined].indexOf(fileContent) === -1 ? fileContent : _fsExtra2.default.readFileSync(src, { encoding: 'utf8' });

                if (!(_fsExtra2.default.existsSync(dest) && !overwrite)) {
                  _context7.next = 9;
                  break;
                }

                console.log(_chalk2.default.gray('\n  File already exists ' + dest + '\n'));
                return _context7.abrupt('return');

              case 9:
                console.log(_chalk2.default.yellow('\n  Adding into file -> ' + dest + '\n'));
                console.log(_chalk2.default.yellow((0, _stringFormatter.leftPad)(fileContent, ' ', 2)));
                _fsExtra2.default.writeFileSync(dest, fileContent, { encoding: 'utf8' });

                if (!chmod) {
                  _context7.next = 15;
                  break;
                }

                _context7.next = 15;
                return this.shell({ command: 'chmod ' + chmod + ' ' + dest });

              case 15:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function addFile() {
        return _ref13.apply(this, arguments);
      }

      return addFile;
    }()

    /**
     * copy copies directory
     *
     * @param {Object} opts
     * @param {String} src           - File path
     * @param {String} dest          - Destination of file to add
     * @param {Boolean} [overwrite]   - overwrite file if doesn't exist
     */

  }, {
    key: 'copy',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8() {
        var _ref16 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            src = _ref16.src,
            dest = _ref16.dest,
            overwrite = _ref16.overwrite;

        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Copy Directory');
                _context8.next = 3;
                return (0, _fsUtils.relativeFromProjectRoot)(dest);

              case 3:
                dest = _context8.sent;

                if (!(_fsExtra2.default.existsSync(dest) && !overwrite)) {
                  _context8.next = 7;
                  break;
                }

                console.log(_chalk2.default.gray('\n  Already exists ' + dest + '\n'));
                return _context8.abrupt('return');

              case 7:
                console.log(_chalk2.default.yellow('\n  Copying file -> ' + dest + '\n'));
                _fsExtra2.default.copySync(src, dest, { overwrite: overwrite });

              case 9:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function copy() {
        return _ref15.apply(this, arguments);
      }

      return copy;
    }()

    /**
     * templateFile creates file from a given template
     *
     * @param {Object} opts
     * @param {String} src           - File path to source handlebars template
     * @param {Object} args          - Arguments to pass into template
     * @param {String} dest          - Destination file path
     * @param {Boolean} [overwrite]   - overwrite file if doesn't exist
     */

  }, {
    key: 'templateFile',
    value: function () {
      var _ref17 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9() {
        var _ref18 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            src = _ref18.src,
            _ref18$args = _ref18.args,
            args = _ref18$args === undefined ? {} : _ref18$args,
            dest = _ref18.dest,
            overwrite = _ref18.overwrite;

        var compiled, rendered, paddedRendered;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                (0, _logger.taskAPILogHeader)('TASK', 'Template File');
                _context9.next = 3;
                return (0, _fsUtils.relativeFromProjectRoot)(dest);

              case 3:
                dest = _context9.sent;

                if (!(_fsExtra2.default.existsSync(dest) && !overwrite)) {
                  _context9.next = 7;
                  break;
                }

                console.log(_chalk2.default.gray('\n  File already exists ' + dest + '\n'));
                return _context9.abrupt('return');

              case 7:
                compiled = _lodash2.default.template(_fsExtra2.default.readFileSync(src, { encoding: 'utf8' }));
                rendered = compiled(args);

                console.log(_chalk2.default.yellow('\n  From ' + src + ' with args'));
                console.log(_chalk2.default.yellow((0, _stringFormatter.leftPad)((0, _stringify2.default)(args, null, '  '), ' ', 2)));
                console.log(_chalk2.default.yellow('\n  Copying to -> ' + dest + '\n'));
                paddedRendered = (0, _stringFormatter.leftPad)(rendered, ' ', 2);

                console.log(_chalk2.default.yellow(paddedRendered));
                _fsExtra2.default.writeFileSync(dest, rendered, { encoding: 'utf8' });

              case 15:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function templateFile() {
        return _ref17.apply(this, arguments);
      }

      return templateFile;
    }()
  }]);
  return TaskAPI;
}();

exports.default = new TaskAPI();