'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = execAsync;

var _child_process = require('child_process');

var _process = require('process');

var _process2 = _interopRequireDefault(_process);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function execAsync(command) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$pipe = _ref.pipe,
      pipe = _ref$pipe === undefined ? false : _ref$pipe;

  return new _promise2.default(function (resolve, reject) {
    var child = (0, _child_process.exec)(command, function (err, stdout, stderr) {
      if (err) {
        reject(err);
      }
      resolve({ err: err, stdout: stdout, stderr: stderr });
    });
    if (pipe) {
      child.stdout.pipe(_process2.default.stdout);
      child.stderr.pipe(_process2.default.stderr);
    }
  });
}