'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getProjectRootPath = exports.areCommandsInstalled = exports.isCommandInstalled = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**
 * @param {String} command - check if command line tool exists ex. 'git', 'npm'
 * @returns {Boolean}
 */
// TODO this might need to be improved on to not use 'which'
var isCommandInstalled = exports.isCommandInstalled = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(command) {
    var _ref2, stdout;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _execAsync2.default)('which ' + command);

          case 2:
            _ref2 = _context.sent;
            stdout = _ref2.stdout;
            return _context.abrupt('return', Boolean(stdout.trim()));

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function isCommandInstalled(_x) {
    return _ref.apply(this, arguments);
  };
}();

/**
 * Check if commands are installed
 *
 * ex.
 *
 * [['yarn', 'npm'], 'git']
 * =
 * ('yarn' || 'npm') && 'git'
 *
 * @param {Array.<String>} commands - refer to ex
 */


var areCommandsInstalled = exports.areCommandsInstalled = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(commands) {
    var i, commandsToCheck, hasTheseCommands;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            i = 0;

          case 1:
            if (!(i < commands.length)) {
              _context2.next = 12;
              break;
            }

            commandsToCheck = [].concat(commands[i]);
            _context2.next = 5;
            return _promise2.default.all(commandsToCheck.map(isCommandInstalled));

          case 5:
            _context2.t0 = Boolean;
            hasTheseCommands = _context2.sent.some(_context2.t0);

            if (hasTheseCommands) {
              _context2.next = 9;
              break;
            }

            throw new Error('Missing dependencies \'' + checkForThese + '\'');

          case 9:
            i++;
            _context2.next = 1;
            break;

          case 12:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function areCommandsInstalled(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

/**
 * returns project root based on where .git is located in the ancestor nodes
 *
 * @returns {String} project root dir
 */


var getProjectRootPath = exports.getProjectRootPath = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    var _ref5, stdout;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;
            _context3.next = 3;
            return (0, _execAsync2.default)('git rev-parse --show-toplevel');

          case 3:
            _ref5 = _context3.sent;
            stdout = _ref5.stdout;
            return _context3.abrupt('return', stdout.trim());

          case 8:
            _context3.prev = 8;
            _context3.t0 = _context3['catch'](0);
            return _context3.abrupt('return', '');

          case 11:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[0, 8]]);
  }));

  return function getProjectRootPath() {
    return _ref4.apply(this, arguments);
  };
}();

var _execAsync = require('utils/execAsync');

var _execAsync2 = _interopRequireDefault(_execAsync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }